diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index 77a5162ef..eaeb793e3 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -911,6 +884,7 @@ public final class RenderBlocks {
         double zMin = z + bounds.minZ();
         double zMax = z + bounds.maxZ();
 
+        tessellator.setNormal(1, 0, 0);
         if (this.enableAO) {
             tessellator.setLightmapCoord1i(this.lightmapCoordTopLeft);
             tessellator.setColorOpaque3f(this.colorRedTopLeft, this.colorGreenTopLeft, this.colorBlueTopLeft);
@@ -930,5 +904,6 @@ public final class RenderBlocks {
             tessellator.addVertexWithUV(xMax, yMax, zMin, uMax2, vMin2);
             tessellator.addVertexWithUV(xMax, yMax, zMax, uMin, vMin);
         }
+        tessellator.setNormal(0, 1, 0);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
index 0b67e399b..8342a41c7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCompass.java
@@ -12,7 +12,7 @@ import net.minecraft.core.world.pos.TilePos;
 
 public class DynamicTextureCompass extends DynamicTexture {
 	
-	private Minecraft mc;
+	private final Minecraft mc;
 	
 	private byte[] compassImageData;
 	
@@ -30,16 +30,16 @@ public class DynamicTextureCompass extends DynamicTexture {
 	public void postInit() {
 		initTexture();
 		
-		BufferedImage atlas = targetTexture.parentAtlas.atlas;
-		compassImageData = new byte[targetTexture.getArea() * 4];
+		BufferedImage atlas = this.targetTexture.parentAtlas.colorImage;
+        this.compassImageData = new byte[this.targetTexture.getArea() * 4];
 
-		for(int x = 0; x < targetTexture.width; x++) {
-			for(int y = 0; y < targetTexture.height; y++) {
-				putPixel(compassImageData, y * targetTexture.width + x, atlas.getRGB(targetTexture.iconX + x, targetTexture.iconY + y));
+		for(int x = 0; x < this.targetTexture.width; x++) {
+			for(int y = 0; y < this.targetTexture.height; y++) {
+				putPixel(this.compassImageData, y * this.targetTexture.width + x, atlas.getRGB(this.targetTexture.iconX + x, this.targetTexture.iconY + y));
 			}
 		}
-		
-		scaleFactor = targetTexture.width / 16.0;
+
+        this.scaleFactor = this.targetTexture.width / 16.0;
 	}
 	@Override
 	public boolean runUpdates(boolean isPaused) {
@@ -49,16 +49,16 @@ public class DynamicTextureCompass extends DynamicTexture {
 	@Override
 	public void update() {
 
-		for (int _x = 0; _x < targetTexture.width; _x++) {
-			for(int _y = 0; _y < targetTexture.height; _y++) {
-				int i = _y * targetTexture.width + _x;
+		for (int _x = 0; _x < this.targetTexture.width; _x++) {
+			for(int _y = 0; _y < this.targetTexture.height; _y++) {
+				int i = _y * this.targetTexture.width + _x;
 
 				int a = this.compassImageData[i * 4 + 3] & 0xFF;
-				int r = this.compassImageData[i * 4 + 0] & 0xFF;
+				int r = this.compassImageData[i * 4] & 0xFF;
 				int g = this.compassImageData[i * 4 + 1] & 0xFF;
 				int b = this.compassImageData[i * 4 + 2] & 0xFF;
 
-				this.imageData[i * 4 + 0] = (byte)r;
+				this.imageData[i * 4] = (byte)r;
 				this.imageData[i * 4 + 1] = (byte)g;
 				this.imageData[i * 4 + 2] = (byte)b;
 				this.imageData[i * 4 + 3] = (byte)a;
@@ -109,34 +109,34 @@ public class DynamicTextureCompass extends DynamicTexture {
 		int b;
 		int a;
 
-        double xs = (targetTexture.width / 2.0) + 0.5;
-		double ys = (targetTexture.height / 2.0) - 0.5;
+        double xs = (this.targetTexture.width / 2.0) + 0.5;
+		double ys = (this.targetTexture.height / 2.0) - 0.5;
 		
-		for(int i = (int)(-4 * scaleFactor); i <= (int)(4 * scaleFactor); ++i) {
+		for(int i = (int)(-4 * this.scaleFactor); i <= (int)(4 * this.scaleFactor); ++i) {
 			x2 = (int)(xs + y * (double)i * 0.3D);
 			y2 = (int)(ys - x * (double)i * 0.3D * 0.5D);
-			j = y2 * targetTexture.width + x2;
+			j = y2 * this.targetTexture.width + x2;
 			r = 100;
 			g = 100;
 			b = 100;
 			a = 255;
 
-			this.imageData[j * 4 + 0] = (byte)r;
+			this.imageData[j * 4] = (byte)r;
 			this.imageData[j * 4 + 1] = (byte)g;
 			this.imageData[j * 4 + 2] = (byte)b;
 			this.imageData[j * 4 + 3] = (byte)a;
 		}
 
-		for(int i = (int)(-8 * scaleFactor); i <= (int)(16 * scaleFactor); ++i) {
+		for(int i = (int)(-8 * this.scaleFactor); i <= (int)(16 * this.scaleFactor); ++i) {
 			x2 = (int)(xs + x * (double)i * 0.3D);
 			y2 = (int)(ys + y * (double)i * 0.3D * 0.5D);
-			j = y2 * targetTexture.width + x2;
+			j = y2 * this.targetTexture.width + x2;
 			r = i >= 0 ? 255 : 100;
 			g = i >= 0 ? 20 : 100;
 			b = i >= 0 ? 20 : 100;
 			a = 255;
 
-			this.imageData[j * 4 + 0] = (byte)r;
+			this.imageData[j * 4] = (byte)r;
 			this.imageData[j * 4 + 1] = (byte)g;
 			this.imageData[j * 4 + 2] = (byte)b;
 			this.imageData[j * 4 + 3] = (byte)a;
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
index 89295e750..1d9739ffa 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureCustom.java
@@ -33,20 +33,16 @@ public class DynamicTextureCustom extends DynamicTexture {
 
 		this.properties = animationProperties;
 
-		BufferedImage image = texture.getImageStorage();
 		try {
-			if(image == null) {
-				throw new TexturePackException("Could not load image!");
-			}
-			if(image.getHeight() < image.getWidth()) {
+			if(texture.height < texture.width) {
 				throw new TexturePackException("Height is smaller than width!");
 			}
 		}catch (TexturePackException e) {
 			throw new TexturePackException("Error in animation " + texture.namespaceId, e);
 		}
 
-		int width = image.getWidth();
-		int height = image.getHeight();
+		int width = texture.width;
+		int height = texture.height;
 
 		int tileWidth = width;
 		int tileHeight = (animationProperties.height * width) / animationProperties.width ;
@@ -56,29 +52,31 @@ public class DynamicTextureCustom extends DynamicTexture {
 		this.frameCount = height / tileHeight;
 
 		if (animationProperties.frames != null) {
-			indices = animationProperties.frames.size();
+            this.indices = animationProperties.frames.size();
 			for (AnimationProperties.Frame f : animationProperties.frames) {
-				if (f.index >= frameCount) {
-					throw new TexturePackException("Animation in '" + texture.namespaceId + "' illegally attempts to reference index '" + f.index + "' when theres only '" + frameCount + "' possible frames!");
+				if (f.index >= this.frameCount) {
+					throw new TexturePackException("Animation in '" + texture.namespaceId + "' illegally attempts to reference index '" + f.index + "' when theres only '" + this.frameCount + "' possible frames!");
 				}
 			}
 		} else {
-			indices = frameCount;
+            this.indices = this.frameCount;
 		}
 
 
-		frameData = new byte[tileWidth * tileHeight * 4 * frameCount];
-		for(int frame=0; frame < frameCount; frame++) {
+		BufferedImage image = texture.parentAtlas.getImage("color", texture);
+
+        this.frameData = new byte[tileWidth * tileHeight * 4 * this.frameCount];
+		for(int frame = 0; frame < this.frameCount; frame++) {
 			for(int x=0; x < tileWidth; x++) {
 				for(int y=0; y < tileHeight; y++) {
 					int c = image.getRGB(x, frame * tileHeight + y);
 					int i = frame * tileWidth * tileHeight + y * tileWidth + x;
-					putPixel(frameData, i, c);
+					putPixel(this.frameData, i, c);
 				}
 			}
 		}
 
-		tickWhenPaused = texture.parentAtlas.tickWhenPaused();
+        this.tickWhenPaused = texture.parentAtlas.tickWhenPaused();
 	}
 
 	@Override
@@ -88,70 +86,70 @@ public class DynamicTextureCustom extends DynamicTexture {
 	
 	@Override
 	public void update() {
-		if(properties.interpolate) {
-			if(delayUntilNextFrame > 0) {
-				delayUntilNextFrame--;
+		if(this.properties.interpolate) {
+			if(this.delayUntilNextFrame > 0) {
+                this.delayUntilNextFrame--;
 			}
 			
-			if(delayUntilNextFrame <= 0) {
+			if(this.delayUntilNextFrame <= 0) {
 				progressFrame();
 			}
 
-			float blendFactor = 1.0f - delayUntilNextFrame / (float) frameLength;
+			float blendFactor = 1.0f - this.delayUntilNextFrame / (float) this.frameLength;
 			
-			if(previousFrame == -1) {
-				transferFrame(currentFrame);
+			if(this.previousFrame == -1) {
+				transferFrame(this.currentFrame);
 			}else {
-				transferBlendedFrame(previousFrame, currentFrame, blendFactor);
+				transferBlendedFrame(this.previousFrame, this.currentFrame, blendFactor);
 			}
 			
 			return;
 		}
 		
-		if(delayUntilNextFrame > 0) {
-			delayUntilNextFrame--;
-			if(delayUntilNextFrame > 0) {
+		if(this.delayUntilNextFrame > 0) {
+            this.delayUntilNextFrame--;
+			if(this.delayUntilNextFrame > 0) {
 				return;
 			}
 		}
 		
 		progressFrame();
 
-		if(currentFrame != previousFrame) {
-			transferFrame(currentFrame);
+		if(this.currentFrame != this.previousFrame) {
+			transferFrame(this.currentFrame);
 		}
 	}
 	private void progressFrame() {
-		frameLength = delayUntilNextFrame = getNextFrameDelay();
-		if (properties.random) {
-			currentIndex = rand.nextInt(indices);
+        this.frameLength = this.delayUntilNextFrame = getNextFrameDelay();
+		if (this.properties.random) {
+            this.currentIndex = rand.nextInt(this.indices);
 		} else {
-			currentIndex = (currentIndex + 1) % indices;
+            this.currentIndex = (this.currentIndex + 1) % this.indices;
 		}
-		previousFrame = currentFrame;
-		currentFrame = getNextFrame();
+        this.previousFrame = this.currentFrame;
+        this.currentFrame = getNextFrame();
 	}
 	
 	private int getNextFrame() {
-		return properties.frames == null ? currentIndex : properties.frames.get(currentIndex).index;
+		return this.properties.frames == null ? this.currentIndex : this.properties.frames.get(this.currentIndex).index;
 	}
 
 	private int getNextFrameDelay() {
-		if (properties.frames == null) return properties.frametime;
-		return properties.frames.get(currentIndex).time;
+		if (this.properties.frames == null) return this.properties.frametime;
+		return this.properties.frames.get(this.currentIndex).time;
 	}
 	
 	private void transferFrame(int frame) {
 		try {
-			for(int x0 = 0; x0 < targetTexture.width; x0++) {
-				for(int y0 = 0; y0 < targetTexture.height; y0++) {
-					int i = (frame * targetTexture.getArea() + y0 * targetTexture.width + x0) << 2;
-					int j = (y0 * targetTexture.width + x0) << 2;
-
-					imageData[j + 0] = frameData[i + 0];
-					imageData[j + 1] = frameData[i + 1];
-					imageData[j + 2] = frameData[i + 2];
-					imageData[j + 3] = frameData[i + 3];
+			for(int x0 = 0; x0 < this.targetTexture.width; x0++) {
+				for(int y0 = 0; y0 < this.targetTexture.height; y0++) {
+					int i = (frame * this.targetTexture.getArea() + y0 * this.targetTexture.width + x0) << 2;
+					int j = (y0 * this.targetTexture.width + x0) << 2;
+
+                    this.imageData[j] = this.frameData[i];
+                    this.imageData[j + 1] = this.frameData[i + 1];
+                    this.imageData[j + 2] = this.frameData[i + 2];
+                    this.imageData[j + 3] = this.frameData[i + 3];
 				}
 			}
 		} catch (Exception e) {
@@ -165,16 +163,16 @@ public class DynamicTextureCustom extends DynamicTexture {
 		}else if(blendFactor >= 1.0f) {
 			transferFrame(frame2);
 		}else {
-			for(int x0 = 0; x0 < targetTexture.width; x0++) {
-				for(int y0 = 0; y0 < targetTexture.height; y0++) {
-					int i = (frame1 * targetTexture.getArea() + y0 * targetTexture.width + x0) << 2;
-					int j = (frame2 * targetTexture.getArea() + y0 * targetTexture.width + x0) << 2;
-					int k = (y0 * targetTexture.width + x0) << 2;
-
-					imageData[k + 0] = blend(frameData[i + 0], frameData[j + 0], blendFactor);
-					imageData[k + 1] = blend(frameData[i + 1], frameData[j + 1], blendFactor);
-					imageData[k + 2] = blend(frameData[i + 2], frameData[j + 2], blendFactor);
-					imageData[k + 3] = blend(frameData[i + 3], frameData[j + 3], blendFactor);
+			for(int x0 = 0; x0 < this.targetTexture.width; x0++) {
+				for(int y0 = 0; y0 < this.targetTexture.height; y0++) {
+					int i = (frame1 * this.targetTexture.getArea() + y0 * this.targetTexture.width + x0) << 2;
+					int j = (frame2 * this.targetTexture.getArea() + y0 * this.targetTexture.width + x0) << 2;
+					int k = (y0 * this.targetTexture.width + x0) << 2;
+
+                    this.imageData[k] = blend(this.frameData[i], this.frameData[j], blendFactor);
+                    this.imageData[k + 1] = blend(this.frameData[i + 1], this.frameData[j + 1], blendFactor);
+                    this.imageData[k + 2] = blend(this.frameData[i + 2], this.frameData[j + 2], blendFactor);
+                    this.imageData[k + 3] = blend(this.frameData[i + 3], this.frameData[j + 3], blendFactor);
 				}
 			}
 		}
@@ -186,6 +184,6 @@ public class DynamicTextureCustom extends DynamicTexture {
 	}
 	@Override
 	public boolean runUpdates(boolean isPaused) {
-		return mc.gameSettings.animations.value != 0 && (!isPaused || tickWhenPaused);
+		return this.mc.gameSettings.animations.value != 0 && (!isPaused || this.tickWhenPaused);
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
index a975e53cc..2e8a478b2 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureFireflyJar.java
@@ -12,16 +12,13 @@ public class DynamicTextureFireflyJar extends DynamicTexture {
 
 	public DynamicTextureFireflyJar(IconCoordinate texture) {
         super(texture);
-		BufferedImage image = texture.getImageStorage();
-		if(image == null) {
-			throw new TexturePackException("Could not load image from texture'" + texture.namespaceId + "'!");
-		}
-        texture.setDimension(image.getWidth(), image.getHeight());
+
         this.originalData = new byte[texture.getArea() * 4];
+        int[] data = texture.parentAtlas.getIconData("color", texture, new int[texture.getArea()]);
 
 		for(int x = 0; x < texture.width; x++) {
 			for(int y = 0; y < texture.height; y++) {
-				putPixel(originalData, y * texture.width + x, image.getRGB(x, y));
+				putPixel(this.originalData, y * texture.width + x, data[y * texture.width + x]);
 			}
 		}
 	}
@@ -33,7 +30,7 @@ public class DynamicTextureFireflyJar extends DynamicTexture {
 
     private float getInternalBrightness()
     {
-        float b = ((float) Math.sin(ticks / 10f) + 1.0f) / 2f;
+        float b = ((float) Math.sin(this.ticks / 10f) + 1.0f) / 2f;
         return MathHelper.clamp(b, 0f, 1f);
     }
 
@@ -44,19 +41,19 @@ public class DynamicTextureFireflyJar extends DynamicTexture {
     @Override
     public void update()
     {
-        ticks++;
+        this.ticks++;
         float br = getInternalBrightness();
 
-        for (int x = 0; x < targetTexture.width; x++){
-            for (int y = 0; y < targetTexture.height; y++)
+        for (int x = 0; x < this.targetTexture.width; x++){
+            for (int y = 0; y < this.targetTexture.height; y++)
             {
-                int i = y * targetTexture.width + x;
+                int i = y * this.targetTexture.width + x;
                 int a = this.originalData[i * 4 + 3] & 0xFF;
-                int r = this.originalData[i * 4 + 0] & 0xFF;
+                int r = this.originalData[i * 4] & 0xFF;
                 int g = this.originalData[i * 4 + 1] & 0xFF;
                 int b = this.originalData[i * 4 + 2] & 0xFF;
 
-                if (x >= targetTexture.width * (6 / 16f) && x < targetTexture.width * (10 / 16f) && y >= targetTexture.height * (6 / 16f) && y < targetTexture.height)
+                if (x >= this.targetTexture.width * (6 / 16f) && x < this.targetTexture.width * (10 / 16f) && y >= this.targetTexture.height * (6 / 16f) && y < this.targetTexture.height)
                 {
 
                     float rf = r / 255f;
@@ -67,9 +64,9 @@ public class DynamicTextureFireflyJar extends DynamicTexture {
                     float maxG = MathHelper.clamp(gf + 0.1f, 0.0f, 1.0f);
                     float maxB = MathHelper.clamp(bf + 0.1f, 0.0f, 1.0f);
 
-                    float tMinR = MathHelper.lerp(minR, rf, 0.85f);
-                    float tMinG = MathHelper.lerp(minG, gf, 0.85f);
-                    float tMinB = MathHelper.lerp(minB, bf, 0.85f);
+                    float tMinR = MathHelper.lerp(this.minR, rf, 0.85f);
+                    float tMinG = MathHelper.lerp(this.minG, gf, 0.85f);
+                    float tMinB = MathHelper.lerp(this.minB, bf, 0.85f);
 
                     if (br < 0.5f)
                     {
@@ -90,7 +87,7 @@ public class DynamicTextureFireflyJar extends DynamicTexture {
 
                 }
 
-                this.imageData[i * 4 + 0] = (byte) r;
+                this.imageData[i * 4] = (byte) r;
                 this.imageData[i * 4 + 1] = (byte) g;
                 this.imageData[i * 4 + 2] = (byte) b;
                 this.imageData[i * 4 + 3] = (byte) a;
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java
index fff2e2380..5faef5228 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureRotating.java
@@ -10,103 +10,103 @@ import net.minecraft.core.util.helper.MathHelper;
 
 public abstract class DynamicTextureRotating extends DynamicTexture {
 
-	protected final Minecraft mc;
-
-	protected byte[] dialImageData;
-	protected int dialTexRes;
-
-	protected byte[] clockImageData;
-	
-	protected double angleFinal;
-	protected double delta;
-
-	public DynamicTextureRotating(Minecraft minecraft, IconCoordinate texture) {
-		super(texture);
-		this.mc = minecraft;
-	}
-	
-	@Override
-	public void postInit() {
-		initTexture();
-
-		BufferedImage atlas = targetTexture.parentAtlas.atlas;
-		clockImageData = new byte[targetTexture.getArea() * 4];
-		for (int x = 0; x < targetTexture.width; x++) {
-			for (int y = 0; y < targetTexture.height; y++) {
-				putPixel(clockImageData, y * targetTexture.width + x, atlas.getRGB(targetTexture.iconX + x, targetTexture.iconY + y));
-			}
-		}
-	}
-
-	public abstract double getAngle();
-	
-	public void updateAngle() {
-		double angle = getAngle();
-
-		double angleSmooth;
-		for (angleSmooth = angle - this.angleFinal; angleSmooth < -MathHelper.PI; ) {
-			angleSmooth += MathHelper.PI * 2;
-		}
-
-		while (angleSmooth >= MathHelper.PI) {
-			angleSmooth -= MathHelper.PI * 2;
-		}
-		
-		if (angleSmooth < -1.0D) angleSmooth = -1.0D;
-		if (angleSmooth > 1.0D) angleSmooth = 1.0D;
-		
-		this.delta += angleSmooth * 0.1D;
-		this.delta *= 0.8D;
-		this.angleFinal += this.delta;
-	}
-
-	@Override
-	public void update() {
-		updateAngle();
-		
-		double x = Math.sin(this.angleFinal);
-		double y = Math.cos(this.angleFinal);
-
-		for (int _x = 0; _x < targetTexture.width; _x++) {
-			for (int _y = 0; _y < targetTexture.height; _y++) {
-				int i = _y * targetTexture.width + _x;
-				int a = this.clockImageData[i * 4 + 3] & 0xFF;
-				int r = this.clockImageData[i * 4 + 0] & 0xFF;
-				int g = this.clockImageData[i * 4 + 1] & 0xFF;
-				int b = this.clockImageData[i * 4 + 2] & 0xFF;
+    protected final Minecraft mc;
+
+    protected byte[] dialImageData;
+    protected int dialTexRes;
+
+    protected byte[] clockImageData;
+
+    protected double angleFinal;
+    protected double delta;
+
+    public DynamicTextureRotating(Minecraft minecraft, IconCoordinate texture) {
+        super(texture);
+        this.mc = minecraft;
+    }
+
+    @Override
+    public void postInit() {
+        initTexture();
+
+        BufferedImage atlas = this.targetTexture.parentAtlas.colorImage;
+        this.clockImageData = new byte[this.targetTexture.getArea() * 4];
+        for (int x = 0; x < this.targetTexture.width; x++) {
+            for (int y = 0; y < this.targetTexture.height; y++) {
+                putPixel(this.clockImageData, y * this.targetTexture.width + x, atlas.getRGB(this.targetTexture.iconX + x, this.targetTexture.iconY + y));
+            }
+        }
+    }
+
+    public abstract double getAngle();
+
+    public void updateAngle() {
+        double angle = getAngle();
+
+        double angleSmooth;
+        for (angleSmooth = angle - this.angleFinal; angleSmooth < -MathHelper.PI; ) {
+            angleSmooth += MathHelper.PI * 2;
+        }
+
+        while (angleSmooth >= MathHelper.PI) {
+            angleSmooth -= MathHelper.PI * 2;
+        }
+
+        if (angleSmooth < -1.0D) angleSmooth = -1.0D;
+        if (angleSmooth > 1.0D) angleSmooth = 1.0D;
+
+        this.delta += angleSmooth * 0.1D;
+        this.delta *= 0.8D;
+        this.angleFinal += this.delta;
+    }
+
+    @Override
+    public void update() {
+        updateAngle();
+
+        double x = Math.sin(this.angleFinal);
+        double y = Math.cos(this.angleFinal);
+
+        for (int _x = 0; _x < this.targetTexture.width; _x++) {
+            for (int _y = 0; _y < this.targetTexture.height; _y++) {
+                int i = _y * this.targetTexture.width + _x;
+                int a = this.clockImageData[i * 4 + 3] & 0xFF;
+                int r = this.clockImageData[i * 4] & 0xFF;
+                int g = this.clockImageData[i * 4 + 1] & 0xFF;
+                int b = this.clockImageData[i * 4 + 2] & 0xFF;
 
 //			r = b = 255; g = 0;
 //			If the pixel in the clock icon is colored pink (Red and Blue are equal), it will be replaced a pixel from the dial texture
-				if (r == b && g == 0 && b > 0) {
-					double pixelBrightness = r / 256.0;
+                if (r == b && g == 0 && b > 0) {
+                    double pixelBrightness = r / 256.0;
 
-					double x2 = -((double) (_x) / (targetTexture.width-1) - 0.5D);
-					double y2 =   (double) (_y) / (targetTexture.height-1) - 0.5D;
+                    double x2 = -((double) (_x) / (this.targetTexture.width - 1) - 0.5D);
+                    double y2 = (double) (_y) / (this.targetTexture.height - 1) - 0.5D;
 
-					int x3 = (int) ((x2 * y + y2 * x + 0.5D) * dialTexRes);
-					int y3 = (int) ((y2 * y - x2 * x + 0.5D) * dialTexRes);
+                    int x3 = (int) ((x2 * y + y2 * x + 0.5D) * this.dialTexRes);
+                    int y3 = (int) ((y2 * y - x2 * x + 0.5D) * this.dialTexRes);
 
-					//Repeat texture
+                    //Repeat texture
 //				int j = pmod(x3, dialTexRes) + pmod(y3, dialTexRes) * dialTexRes;
-					//Clamp to edge
-					int j = clamp(x3, 0, dialTexRes-1) + clamp(y3, 0, dialTexRes-1) * dialTexRes;
-
-					a = this.dialImageData[j * 4 + 3] & 0xFF;
-					r = this.dialImageData[j * 4 + 0] & 0xFF;
-					g = this.dialImageData[j * 4 + 1] & 0xFF;
-					b = this.dialImageData[j * 4 + 2] & 0xFF;
-
-					r = (int) (r * pixelBrightness);
-					g = (int) (g * pixelBrightness);
-					b = (int) (b * pixelBrightness);
-				}
-
-
-				this.imageData[i * 4 + 0] = (byte) r;
-				this.imageData[i * 4 + 1] = (byte) g;
-				this.imageData[i * 4 + 2] = (byte) b;
-				this.imageData[i * 4 + 3] = (byte) a;
-			}
-		}
-	}
+                    //Clamp to edge
+                    int j = clamp(x3, 0, this.dialTexRes - 1) + clamp(y3, 0, this.dialTexRes - 1) * this.dialTexRes;
+
+                    a = this.dialImageData[j * 4 + 3] & 0xFF;
+                    r = this.dialImageData[j * 4] & 0xFF;
+                    g = this.dialImageData[j * 4 + 1] & 0xFF;
+                    b = this.dialImageData[j * 4 + 2] & 0xFF;
+
+                    r = (int) (r * pixelBrightness);
+                    g = (int) (g * pixelBrightness);
+                    b = (int) (b * pixelBrightness);
+                }
+
+
+                this.imageData[i * 4] = (byte) r;
+                this.imageData[i * 4 + 1] = (byte) g;
+                this.imageData[i * 4 + 2] = (byte) b;
+                this.imageData[i * 4 + 3] = (byte) a;
+            }
+        }
+    }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
index 7b8433298..aaf3e6b8a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/dynamictexture/DynamicTextureTrommel.java
@@ -8,10 +8,10 @@ import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 
 public class DynamicTextureTrommel extends DynamicTextureRotating {
 	
-	private boolean counterClockwise;
+	private final boolean counterClockwise;
 	
 	private double rotation = 0.0;
-	private double speed = 0.12;
+	private final double speed = 0.12;
 	
 	public DynamicTextureTrommel(Minecraft minecraft, IconCoordinate textureIndex, boolean counterClockwise) {
 		super(minecraft, textureIndex);
@@ -23,22 +23,22 @@ public class DynamicTextureTrommel extends DynamicTextureRotating {
 	public void postInit() {
 		initTexture();
 		
-		BufferedImage atlasImage = targetTexture.parentAtlas.atlas;
+		BufferedImage atlasImage = this.targetTexture.parentAtlas.colorImage;
 		
 		IconCoordinate foreground = TextureRegistry.getTexture("minecraft:block/trommel/active_front_foreground");
-		dialImageData = new byte[foreground.getArea() * 4];
+        this.dialImageData = new byte[foreground.getArea() * 4];
 		for(int x=0; x < foreground.width; x++) {
 			for(int y=0; y < foreground.height; y++) {
-				putPixel(dialImageData, y * foreground.width + x, atlasImage.getRGB(foreground.iconX + x, foreground.iconY + y));
+				putPixel(this.dialImageData, y * foreground.width + x, atlasImage.getRGB(foreground.iconX + x, foreground.iconY + y));
 			}
 		}
-		dialTexRes = foreground.width;
+        this.dialTexRes = foreground.width;
 		
 		IconCoordinate background = TextureRegistry.getTexture("minecraft:block/trommel/active_front_background");
-		clockImageData = new byte[background.getArea() * 4];
+        this.clockImageData = new byte[background.getArea() * 4];
 		for(int x=0; x < background.width; x++) {
 			for(int y=0; y < background.height; y++) {
-				putPixel(clockImageData, y * background.width + x, atlasImage.getRGB(background.iconX+ x, background.iconY + y));
+				putPixel(this.clockImageData, y * background.width + x, atlasImage.getRGB(background.iconX+ x, background.iconY + y));
 			}
 		}
 	}
@@ -50,20 +50,20 @@ public class DynamicTextureTrommel extends DynamicTextureRotating {
 	
 	@Override
 	public void updateAngle() {
-		if(counterClockwise) {
-			rotation -= speed;
+		if(this.counterClockwise) {
+            this.rotation -= this.speed;
 			
-			if(rotation < 0) {
-				rotation += Math.PI * 2;
+			if(this.rotation < 0) {
+                this.rotation += Math.PI * 2;
 			}
 			
 		}else {
-			rotation += speed;
+            this.rotation += this.speed;
 			
-			if(rotation > Math.PI * 2) {
-				rotation -= Math.PI * 2;
+			if(this.rotation > Math.PI * 2) {
+                this.rotation -= Math.PI * 2;
 			}
 		}
-		angleFinal = rotation;
+        this.angleFinal = this.rotation;
 	}
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
index f75ee0b23..e8aaee8eb 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
@@ -23,6 +23,7 @@ public final class Shaders {
     public static final @NotNull ShaderProvider PROVIDER_INTERNAL = new ShaderProviderInternal("/shaders/");
 
     public static final @NotNull Shader WORLD = register("world", new Shader());
+    public static final @NotNull Shader TERRAIN = register("terrain", new Shader());
     public static final @NotNull Shader INTERFACE = register("interface", new Shader());
     public static final @NotNull Shader COLOR = register("color", new Shader());
     public static final @NotNull Shader COLOR_WORLD = register("color_world", new Shader());
@@ -45,8 +46,10 @@ public final class Shaders {
                     entry.getValue().uniformBlockBinding(block.name, block.index);
                 }
                 entry.getValue().bind();
-                GL41.glUniform1i(entry.getValue().getUniform("texture0"), 0);
-                GL41.glUniform1i(entry.getValue().getUniform("texture1"), 1);
+                entry.getValue().uniformInt("colortex", 0);
+                entry.getValue().uniformInt("lighttex", 1);
+                entry.getValue().uniformInt("emmisivetex", 2);
+//                entry.getValue().uniformInt("colormasktex", 3);
                 GL41.glUseProgram(0);
             } catch (Exception e) {
                 LOGGER.error("", e);
@@ -63,8 +66,12 @@ public final class Shaders {
                     entry.getValue().uniformBlockBinding(block.name, block.index);
                 }
                 entry.getValue().bind();
-                GL41.glUniform1i(entry.getValue().getUniform("texture0"), 0);
-                GL41.glUniform1i(entry.getValue().getUniform("texture1"), 1);
+                GL41.glUniform1i(entry.getValue().getUniform("colortex"), 0);
+                GL41.glUniform1i(entry.getValue().getUniform("lighttex"), 1);
+                entry.getValue().uniformInt("colortex", 0);
+                entry.getValue().uniformInt("lighttex", 1);
+                entry.getValue().uniformInt("emmisivetex", 2);
+//                entry.getValue().uniformInt("colormasktex", 3);
                 GL41.glUseProgram(0);
             } catch (Exception e) {
                 LOGGER.error("", e);
